clear
clc
close all

 counter=1;
 n2=0;
 datac=0;
    while counter==1
            n2=n2+1;
            
            %Optional Commands for entering and reading an excel file
            file_name=input('Enter file name (with .xlsx at the end): ','s');
            sheet_name=input('Enter sheet name: ','s');
            [raw_data,text]=xlsread(file_name,sheet_name);
            [rn1,cn1]=size(raw_data);
        
            
            %setting up parameters
            spacing=input('Enter the spacing value Tau 0 for t (in sec.): ');
            tau2=input('Enter a Parameter for Tau 2: ');
            tau1=input('Enter a parameter for Tau 1: ');
                
            %Loop for collecting BPM data for each ROI
            datac=datac+1;
            n=2;
            while n<=cn1
                ROI=n-1;

                %Discrete Fourier Analysis
                rawtime=raw_data(:,1);
                totaltime=max(rawtime);
                framespersecond=rn1/totaltime;
                framerate=1/framespersecond;
                tinv=(0:(rn1-1))*framerate;
                t=tinv';
                xdata=raw_data(:,n);
                L6=length(rawtime);
                
                %Interpolating the data
                upperbound1=round(totaltime,0);
                upperbound8=round(totaltime,2);
                xq=[0:0.01:(upperbound8-0.01)];
                xcont=interp1(t,xdata,xq,'pchip');
                xqr=round(xq,2);
                
                
                %integrating the data points (using trapezoid method)
                tau0=0.2;
                time=0;
                
                n6=1;
                
                t2=time+tau1/2;
                t2r=round(t2,2);
                t3=t2-(tau1/2);
                t3r=round(t3,2);
                upperbound2=upperbound1-t2r;
                uppertloc=find(t<=(totaltime-t2),1,'last');
                upperbound7=totaltime-t2;
                while time>=0 && time<=(t(uppertloc))-tau2
                    
                    n7=1;
                    
                    while t2>=time && t2<=time+tau2-(tau1/2)
                        
                        n8=1;
                        while t3>=t2-(tau1/2) && t3<=t2+(tau1/2)
                            t3r=round(t3,2); 
                            tloc=find(xqr == t3r);
                            Y(n7,n8)=xcont(1,tloc);
                            t3=t3+0.01;
                            
                            n8=n8+1;
                            
                        end
                        Fbar1(n6,n7)=trapz(Y(n7,:));
                        Fbar2=(1/tau1)*Fbar1/100;
                        t2=t2+0.01;
                        t2r=round(t2,2);
                        t3=t2-(tau1/2);
                        n7=n7+1;
                        Fbarend=n7-1;
                        F0(1,n6)=min(Fbar2(n6,1:Fbarend));
                    end
                    
                    time=time+spacing;
                    t2=time+(tau1/2);
                    t2r=round(t2,2);
                    t3=t2-(tau1/2);
                    t3r=round(t3,2);
                    n6=n6+1;
                end
                
                L2=length(F0);
                timedata=[t(1,1):spacing:(t(uppertloc)-tau2)];
                timedatar=round(timedata,2);
                n6=1;
                while n6<=L2
                    tloc=find(xqr==timedatar(1,n6));
                    FofT=xcont(1,tloc);
                    RofT(1,n6)=(FofT-F0(n6))/(F0(n6));
                    n6=n6+1;
                end
                
                
                %new frame rate for normalized data
                totaltime2=upperbound7-tau2;
                L12=length(RofT);
                framespersecond2=(L12-1)/totaltime2;
                framerate2=1/framespersecond2;
                
                %Fourier Transform
                y=fft(xdata);
                f1=((0:length(t)-1)/length(t));
                
                %Fourier Transform with normalized data
                y2=fft(RofT);
                f3=((0:length(t)-1)/length(t));
                
            
                %Raw Data Plot
                figure
                grid on
                hold on
                plot(t,raw_data(:,n))
                plot(t,raw_data(:,n),'ko','MarkerFaceColor','k','MarkerSize',2)
                Title1=sprintf('ROI %0.0f Raw Data',ROI);
                title(Title1)
                xlabel('Time (s)')
                ylabel('Mean Intensity')
                hold off
                
                %finding boundary points for scaling raw to same as
                %normalized
                lowbound=find(t>2,1);
                highbound=find(t<20,1,'last');
                
                %Raw Data plot with same scaling as normalized data
                figure
                grid on 
                hold on 
                plot(t(lowbound:highbound,:),raw_data(lowbound:highbound,n))
                plot(t(lowbound:highbound,:),raw_data(lowbound:highbound,n),'ko','MarkerFaceColor','k','MarkerSize',2)
                Title8=sprintf('ROI %0.0f Raw Data scaled to Norm',ROI);
                title(Title8)
                xlabel('Time (s)')
                ylabel('Mean Intensity')
                hold off
                
                %Raw Data with Interpolation Plot
                figure 
                grid on
                hold on 
                plot(t,raw_data(:,n))
                plot(xq,xcont,'ko','MarkerFaceColor','k','MarkerSize',2)
                Title2=sprintf('ROI %0.0f Raw Data with Interpolation',ROI);
                title(Title2)
                xlabel('Time (s)')
                ylabel('Mean Intensity')
                hold off
                
                %Normalized Data plot
                figure
                grid on
                hold on
                plot(timedata(1:end),RofT)
                plot(timedata(1:end),RofT,'ko','MarkerFaceColor','k','MarkerSize',2)
                Title3=sprintf('ROI %0.0f Normalized Data',ROI);
                title(Title3)
                xlabel('Time (s)')
                ylabel('Relative change in Intensity')
                hold off
                
            
                %singled sided amplitude analysis
                L=length(t);
                P2=(y/L)*100;
                L3=length(P2);
                upperbound3=round(L3/2,0);
                P3=abs(P2(3:upperbound3));
                f2=f1(3:upperbound3);
                
                
                %single sided amplitude of normalized data
                L6=length(timedata(1:end-1));
                P4=(y2/L6);
                L7=length(P4);
                upperbound4=round(L7/2,0);
                P5=abs(P4(tau2:upperbound4));
                L13=length(P5);
                f4=((1/L13)*0.5):((1/L13)*0.5):0.5;
                
                
                %plotting single sided amplitude
                figure
                hold on
                bar(f2,P3)
                Title5=sprintf('ROI %0.0f Raw Data Transform',ROI);
                title(Title5)
                xlabel('f(Hz)')
                ylabel('|Power|')
                

                %filtering and finding maximum
                [maxP1,maxpoint1]=max(P3);
                maxf1=f2(maxpoint1);
                
                %raw max to bpm
                frequency1=maxf1/framerate;
                bpm1=frequency1*60;
                
                
                %plotting normalized data amplitude
                figure 
                hold on 
                bar(f4(1:end-1),P5(1:end-1))
                Title7=sprintf('ROI %0.0f Normalized Data Transform',ROI);
                title(Title7)
                xlabel('f(Hz)')
                ylabel('|Power|')
                
                
                %finding max of normalized data amplitude
                [maxP5,maxpoint]=max(P5);
                maxf4=f4(maxpoint);
                
                %converting normalized max to bpm
                frequency2=maxf4/framerate2;
                bpm2=frequency2*60;
                
                %plotting normalized max point
                plot(maxf4,maxP5,'kx','MarkerSize',10)
                hold off
                
                %storing data
                BPMdata(ROI,datac)=bpm1;
                ROIdata(ROI,datac)=datac;
                BPM2data(ROI,datac)=bpm2;
        
                %adding to n for repeat of loop
                n=n+1;
            end
            %menu to select whether or not to read another file as part of the
            %current category
            counter=menu('Do you want to analyze another file?','Yes','No');
    end

    %Formating BPM results
    [rn2,cn2]=size(BPMdata);


    %loop to print BPM results and store them for the excel file
    fprintf('Group #:\tROI#:\tBPM Raw:\tBPM Norm:\n')
    Table2{1,1}='Group';
    Table2{1,2}='ROI#';
    Table2{1,3}='BPM1';
    Table2{1,4}='BPMNorm';
    n3=1;
    n5=2;
    while n3<=cn2
        BPMperfile1=BPMdata(:,n3);
        BPMperfile2=BPM2data(:,n3);
        L5=length(BPMperfile1);
        L8=length(BPMperfile2);
        r=1;
    
        while r<=L5
            indBPM1=BPMperfile1(r,:);
            indBPM2=BPMperfile2(r,:);
            if indBPM1~=0
                fprintf('%0.0f\t\t\t%0.0f\t\t%0.0f\t\t\t%0.0f\n',n3,r,indBPM1,indBPM2)
                Table2{n5,1}=n3;
                Table2{n5,2}=r;
                Table2{n5,3}=indBPM1;
                Table2{n5,4}=indBPM2;
            end
            r=r+1;
            n5=n5+1;
        end
        BPMperfile1=[];
        BPMperfile2=[];
        n3=n3+1;
    end
    
    %putting the data into a new excel file
    ask=menu('Would you like to save the data in an excel file?','Yes','No');
    if ask==1
        file_name2=input('Enter a file name to save the bpm data (with .xlsx at the end): ','s');
        sheet_name2=input('Enter a name for the excel sheet you want to save the data in: ','s');
        xlswrite(file_name2,Table2,sheet_name2);
        ask=ask+1;
    end
    